----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 22.09.2023 17:32:08
-- Design Name: 
-- Module Name: add4 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity add4 is
    Port ( ai : in STD_LOGIC_VECTOR (3 downto 0);
           bi : in STD_LOGIC_VECTOR (3 downto 0);
           si : out STD_LOGIC_VECTOR (4 downto 0));
end add4;

architecture Behavioral of add4 is
component add1 is
    Port ( a : in STD_LOGIC;
           b : in STD_LOGIC;
           r : in STD_LOGIC;
           s : out STD_LOGIC;
           ro : out STD_LOGIC);
end component;
--signal ai,bi : STD_LOGIC_VECTOR (3 downto 0);
--signal si :  STD_LOGIC_VECTOR (4 downto 0);
signal rin : STD_LOGIC_VECTOR (2 downto 0);

begin
    c0 : add1 port map (ai(0),bi(0),'0',si(0),rin(0));
    c1 : add1 port map (ai(1),bi(1),rin(0),si(1),rin(1));
    c2 : add1 port map (ai(2),bi(2),rin(1),si(2),rin(2));
    c3 : add1 port map (ai(3),bi(3),rin(2),si(3),si(4));

end Behavioral;
