----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 22.09.2023 15:25:18
-- Design Name: 
-- Module Name: mux_tb - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mux_tb is
--  Port ( );
end mux_tb;

architecture Behavioral of mux_tb is
component mux is
    Port ( a : in STD_LOGIC;
           b : in STD_LOGIC;
           sel : in STD_LOGIC;
           s : out STD_LOGIC);
end component;
signal a,b,sel,s : STD_LOGIC;
begin
    c1 : mux port map (a,b,sel,s);
    process
    begin
        a <= '0';
        b <= '1';
        sel <= '0';
        wait for 10ns;
        a <= '1';
        wait for 10ns;
        a <= '0';
        wait for 10ns;
        sel <= '1';
        wait for 10ns;
        b <= '0';
        wait for 10ns;
        b <= '1';
        wait for 10ns;
        sel <= '0';
        wait for 10ns;
    end process;
end Behavioral;
